Debian Bug report logs - #563050
beast: FTBFS on some architectures (infinite loop?)

version graph

Package: src:beast; Maintainer for src:beast is Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>;

Reported by: Jakub Wilk <jwilk@debian.org>

Date: Wed, 30 Dec 2009 11:27:02 UTC

Severity: serious

Tags: patch

Merged with 595743

Found in version beast/0.7.1-5.2

Fixed in version 0.7.4-1

Done: Alessio Treglia <alessio@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, ubanus@users.sf.net, Sam Hocevar (Debian packages) <sam+deb@zoy.org>:
Bug#563050; Package src:beast. (Wed, 30 Dec 2009 11:27:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jakub Wilk <ubanus@users.sf.net>:
New Bug report received and forwarded. Copy sent to ubanus@users.sf.net, Sam Hocevar (Debian packages) <sam+deb@zoy.org>. (Wed, 30 Dec 2009 11:27:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jakub Wilk <ubanus@users.sf.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: beast: FTBFS on some architectures (infinite loop?)
Date: Wed, 30 Dec 2009 12:24:08 +0100
[Message part 1 (text/plain, inline)]
Source: beast
Version: 0.7.1-5.2
Severity: serious
Tags: patch
Justification: no longer builds from source

beast failed to build from some on some architectures:

| gdk-pixbuf-csource --name=keyboard_pixstream keyboard.png >xgen-keyboard.c-temp && cp xgen-keyboard.c-temp keyboard.c && rm -f xgen-keyboard.c-temp
| gdk-pixbuf-csource --name=virtual_input_pixstream virtual-input.png >xgen-virtual-input.c-temp && cp xgen-virtual-input.c-temp virtual-input.c && rm -f xgen-virtual-input.c-temp
| gdk-pixbuf-csource --name=virtual_output_pixstream virtual-output.png >xgen-virtual-output.c-temp && cp xgen-virtual-output.c-temp virtual-output.c && rm -f xgen-virtual-output.c-temp
| gdk-pixbuf-csource --name=virtual_synth_pixstream virtual-synth.png >xgen-virtual-synth.c-temp && cp xgen-virtual-synth.c-temp virtual-synth.c && rm -f xgen-virtual-synth.c-temp
| gdk-pixbuf-csource --name=waveosc_pixstream waveosc.png >xgen-waveosc.c-temp && cp xgen-waveosc.c-temp waveosc.c && rm -f xgen-waveosc.c-temp
| make[4]: Leaving directory `/build/buildd/beast-0.7.1/bse/icons'
| Making all in zintern
| make[4]: Entering directory `/build/buildd/beast-0.7.1/bse/zintern'
| ../../birnet/birnet-zintern -b -z wave-mono ./wave-mono.bse gus-patch ./gus-patch.bse > xgen-bzc		\
| 	&& echo "static const BseZFile bse_zfiles[] = {" >> xgen-bzc			\
| 	&& for i in wave-mono gus-patch ; do				\
| 		uname=$(echo $i | tr a-z- A-Z_);					\
| 		echo "  { \"$i\", $uname""_SIZE, "	>>xgen-bzc;			\
| 		echo "    $uname""_DATA, G_N_ELEMENTS ($uname""_DATA) }," >>xgen-bzc;	\
| 	done										\
| 	&& echo "};" >> xgen-bzc							\
| 	&& cp xgen-bzc bse-zfile.c								\
| 	&& rm -f xgen-bzc
| make[2]: make[3]: make[4]: *** [all-recursive] Terminated
| *** [all-recursive] Terminated
| *** [bse-zfile.c] Terminated
| make[1]: *** [all] Terminated
| make: *** [build-stamp] Terminated
| Build killed with signal 15 after 150 minutes of inactivity

The full build log is available here:
https://buildd.debian.org/fetch.cgi?pkg=beast&arch=powerpc&ver=0.7.1-5.2&stamp=1262051092&file=log&as=raw

My theory why that happens is as follows:

glib defines an external g_atomic_pointer_get() function *and*
g_atomic_pointer_get macro. On some architectures the macro expands to
a g_atomic_pointer_get function call. Beast defines its own 
g_atomic_pointer_get function (it is C++ and it has a slightly different 
prototype, so that's allowed) with g_atomic_pointer_get macro call 
inside. Thus, we have an infinite recursion. Thanks to -O2's tail 
recursive call optimizations we end up with infinite loop rather than 
crash caused by stack overflow.

g_atomic_int_get() function is similarly affected.

I believe that the attached patch fixes this bug. However, it has *not* 
been tested on any affected architecture.

-- 
Jakub Wilk
[atomic.diff (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Sam Hocevar (Debian packages) <sam+deb@zoy.org>:
Bug#563050; Package src:beast. (Mon, 08 Feb 2010 07:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to peter green <plugwash@p10link.net>:
Extra info received and forwarded to list. Copy sent to Sam Hocevar (Debian packages) <sam+deb@zoy.org>. (Mon, 08 Feb 2010 07:51:02 GMT) Full text and rfc822 format available.

Message #10 received at 563050@bugs.debian.org (full text, mbox):

From: peter green <plugwash@p10link.net>
To: 563050@bugs.debian.org, ubanus@users.sf.net
Subject: re: beast: FTBFS on some architectures (infinite loop?)
Date: Mon, 08 Feb 2010 07:48:37 +0000
>I believe that the attached patch fixes this bug. However, it has *not* 
>been tested on any affected architecture.
I tried adding your patch to the end of the quilt series and got a successful build on a qemu mips system.





Information forwarded to debian-bugs-dist@lists.debian.org, Sam Hocevar (Debian packages) <sam+deb@zoy.org>:
Bug#563050; Package src:beast. (Sat, 13 Feb 2010 18:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ilya Barygin <barygin@gmail.com>:
Extra info received and forwarded to list. Copy sent to Sam Hocevar (Debian packages) <sam+deb@zoy.org>. (Sat, 13 Feb 2010 18:09:03 GMT) Full text and rfc822 format available.

Message #15 received at 563050@bugs.debian.org (full text, mbox):

From: Ilya Barygin <barygin@gmail.com>
To: 563050@bugs.debian.org
Subject: tested on i386
Date: Sat, 13 Feb 2010 21:06:25 +0300
atomic.diff fixes build on i386 as well.




Information forwarded to debian-bugs-dist@lists.debian.org, Sam Hocevar (Debian packages) <sam+deb@zoy.org>:
Bug#563050; Package src:beast. (Sat, 20 Feb 2010 14:21:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jakub Wilk <jwilk@debian.org>:
Extra info received and forwarded to list. Copy sent to Sam Hocevar (Debian packages) <sam+deb@zoy.org>. (Sat, 20 Feb 2010 14:21:09 GMT) Full text and rfc822 format available.

Message #20 received at 563050@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: Ilya Barygin <barygin@gmail.com>, 563050@bugs.debian.org
Subject: Re: Bug#563050: tested on i386
Date: Sat, 20 Feb 2010 15:18:44 +0100
[Message part 1 (text/plain, inline)]
* Ilya Barygin <barygin@gmail.com>, 2010-02-13, 21:06:
>atomic.diff fixes build on i386 as well.

I don't think i386 has been ever affected by this bug...

-- 
Jakub Wilk
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Sam Hocevar (Debian packages) <sam+deb@zoy.org>:
Bug#563050; Package src:beast. (Sat, 20 Feb 2010 14:48:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ilya Barygin <barygin@gmail.com>:
Extra info received and forwarded to list. Copy sent to Sam Hocevar (Debian packages) <sam+deb@zoy.org>. (Sat, 20 Feb 2010 14:48:06 GMT) Full text and rfc822 format available.

Message #25 received at 563050@bugs.debian.org (full text, mbox):

From: Ilya Barygin <barygin@gmail.com>
To: Jakub Wilk <jwilk@debian.org>
Cc: 563050@bugs.debian.org
Subject: Re: Bug#563050: tested on i386
Date: Sat, 20 Feb 2010 17:44:58 +0300
[Message part 1 (text/plain, inline)]
В Sat, 20 Feb 2010 15:18:44 +0100
Jakub Wilk <jwilk@debian.org> пишет:

> * Ilya Barygin <barygin@gmail.com>, 2010-02-13, 21:06:
> >atomic.diff fixes build on i386 as well.
> 
> I don't think i386 has been ever affected by this bug...

I'm sorry, I should have mentioned that this is on Ubuntu Lucid.
[signature.asc (application/pgp-signature, attachment)]

Changed Bug submitter to 'Jakub Wilk <jwilk@debian.org>' from 'Jakub Wilk <ubanus@users.sf.net>' Request was from Jakub Wilk <jwilk@debian.org> to control@bugs.debian.org. (Mon, 06 Sep 2010 13:09:06 GMT) Full text and rfc822 format available.

Forcibly Merged 563050 595743. Request was from Jakub Wilk <jwilk@debian.org> to control@bugs.debian.org. (Mon, 06 Sep 2010 13:09:07 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Alessio Treglia <alessio@debian.org> to control@bugs.debian.org. (Sat, 07 May 2011 08:51:30 GMT) Full text and rfc822 format available.

Reply sent to Alessio Treglia <alessio@debian.org>:
You have taken responsibility. (Sat, 07 May 2011 12:39:04 GMT) Full text and rfc822 format available.

Notification sent to Jakub Wilk <jwilk@debian.org>:
Bug acknowledged by developer. (Sat, 07 May 2011 12:39:05 GMT) Full text and rfc822 format available.

Message #36 received at 563050-done@bugs.debian.org (full text, mbox):

From: Alessio Treglia <alessio@debian.org>
To: 563050-done@bugs.debian.org, 563050-submitter@bugs.debian.org
Subject: Closing #563050
Date: Sat, 7 May 2011 14:36:08 +0200
Version: 0.7.4-1

Hi,

the latest upload of beast should fix this.

Regards,

-- 
Alessio Treglia          | www.alessiotreglia.com
Debian Developer         | alessio@debian.org
Ubuntu Core Developer    | quadrispro@ubuntu.com
0FEC 59A5 E18E E04F 6D40 593B 45D4 8C7C DCFC 3FD0




Reply sent to Alessio Treglia <alessio@debian.org>:
You have taken responsibility. (Sat, 07 May 2011 12:39:06 GMT) Full text and rfc822 format available.

Notification sent to Philipp Kern <pkern@debian.org>:
Bug acknowledged by developer. (Sat, 07 May 2011 12:39:07 GMT) Full text and rfc822 format available.

Message sent on to Jakub Wilk <jwilk@debian.org>:
Bug#563050. (Sat, 07 May 2011 12:39:09 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 05 Jun 2011 07:35:39 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 08:53:16 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.